---
title: 'xml:base'
slug: 'Web/XML/xml:base'
tags:
  - Attribute
  - Obsolete
  - Reference
  - SVG
  - XML
  - 'xml:base'
---
<p>{{deprecated_header}}</p>

<p><strong><code>xml:base</code></strong> is like the HTML {{HTMLElement("base")}} element, but can specify the base URI per element as well as the entire document.</p>

<p>The base URL of a element can be queried from a script using <a href="/en-US/docs/Web/API/Node/baseURI">Node.baseURI</a>.</p>

<p>The base URI of an element is:</p>

<ol>
 <li>the base URI specified by an <code>xml:base</code> attribute on the element, if one exists, otherwise</li>
 <li>the base URI of the element's parent element within the document entity or external entity, if one exists, otherwise</li>
 <li>the base URI of the document entity or external entity containing the element.</li>
</ol>

<p>Support was removed from blink (Chrome and Opera) in 2015:</p>

<ul>
 <li><a href="https://bugs.chromium.org/p/chromium/issues/detail?id=341854">Chromium bug 341854</a></li>
 <li><a href="https://groups.google.com/a/chromium.org/forum/#!topic/blink-dev/ZvArHAXyAHM">blink-dev mailing list post</a></li>
</ul>

<p>And from Firefox 66 in {{bug(903372)}}.</p>

<h2 id="Use_cases">Use cases</h2>

<p>If you have an inline SVG you use as icons that needs to work in a document with a <a href="/en-US/docs/Web/HTML/Element/base">HTML BaseElement</a> , you can reset the URI on your icon sprite by setting the xml:base.</p>

<pre class="brush: html;">&lt;html&gt;
  &lt;head&gt;
  &lt;base href="https://mydomain.com"&gt;
  &lt;style&gt;
  .link { stroke: #999; stroke-opacity: .6; }
  marker#arrow { fill: black; }
  &lt;/style&gt;
&lt;/head&gt;
&lt;body&gt;
  &lt;svg width="100%" height="100%" xml:base=""&gt;
    &lt;defs&gt;
      &lt;marker id="arrow" viewBox="0 -5 10 10" refX="0" refY="0" markerWidth="20" markerHeight="20" orient="auto"&gt;
        &lt;path d="M0,-5L10,0L0,5"&gt;&lt;/path&gt;
      &lt;/marker&gt;
    &lt;/defs&gt;
    &lt;line x1="100" y1="100" x2="333" y2="333" marker-start="url(#arrow)" class="link"&gt;&lt;/line&gt;
  &lt;/svg&gt;
&lt;/body&gt;
&lt;/html&gt;</pre>

<p>Imagine a SVG with font references. E.g.</p>

<pre class="brush: xml;">&lt;svg xml:base="https://foobar.s3-eu-west-1.amazonaws.com/uploads/15066845653629"
  width="909" height="1286" viewBox="0 0 909 1286"xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"&gt;
&lt;defs&gt;
&lt;style type="text/css"&gt;&lt;![CDATA[

.s9_999{
font-size: 9.17px;
font-family: ZapfDingbats_ghr;
fill: #161615;
}
]]&gt;&lt;/style&gt;

  &lt;text
    x="647"
    y="412"
    dx="0"
    class="s9_999"
  &gt;r&lt;/text&gt;

&lt;style type="text/css"&gt;&lt;![CDATA[

@font-face {
    font-family: ZapfDingbats_ghr;
    src: url("fonts/ZapfDingbats_ghr.woff") format("woff");
}

]]&gt;&lt;/style&gt;

&lt;/svg&gt;
</pre>

<p>Setting the xml:base on the SVG Element means you can inline the SVG and thereby bypass CORS issue while not changing the base URI for your entire document.</p>

<h2 id="Work-arounds">Work-arounds</h2>

<ul>
 <li><a href="/en-US/docs/Archive/Add-ons/Code_snippets/XML/base_function">xml:base support in old browsers</a></li>
 <li><a href="https://gist.github.com/leonderijke/c5cf7c5b2e424c0061d2">https://gist.github.com/leonderijke/c5cf7c5b2e424c0061d2</a></li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><a href="https://www.w3.org/TR/xmlbase/">XML Base (Second Edition)</a></td>
   <td><span class="spec-REC">Recommendation</span></td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("xml.attributes.base")}}</p>
